#include <DynamixelShield.h>

#if defined(ARDUINO_AVR_UNO) || defined(ARDUINO_AVR_MEGA2560)
  #include <SoftwareSerial.h>
  SoftwareSerial soft_serial(7, 8); // DYNAMIXELShield UART RX/TX
  #define DEBUG_SERIAL soft_serial
#elif defined(ARDUINO_SAM_DUE) || defined(ARDUINO_SAM_ZERO)
  #define DEBUG_SERIAL SerialUSB    
#else
  #define DEBUG_SERIAL Serial
#endif

const float DXL_PROTOCOL_VERSION = 1.0; // Or 1.0 depending on your model
DynamixelShield dxl;

const uint8_t DXL_ID_A = 4;
const uint8_t DXL_ID_B = 2;
const uint8_t DXL_ID_C = 3;

void setup() {
  // For Uno, Nano, Mini, and Mega, use UART port of DYNAMIXEL Shield to debug.
  dxl.begin(Serial);
  Serial.begin(2000000);
  dxl.begin(57600); // Adjust baudrate as necessary
  dxl.setPortProtocolVersion(DXL_PROTOCOL_VERSION);

    // Get DYNAMIXEL information
  dxl.ping(DXL_ID_A);
  dxl.ping(DXL_ID_B);
  dxl.ping(DXL_ID_C);

  // Initialize all servos
  dxl.torqueOff(DXL_ID_A);
  dxl.setOperatingMode(DXL_ID_A, OP_CURRENT_BASED_POSITION);
  dxl.torqueOn(DXL_ID_A);
 
  dxl.torqueOff(DXL_ID_B);
  dxl.setOperatingMode(DXL_ID_B, OP_CURRENT_BASED_POSITION);
  dxl.torqueOn(DXL_ID_B);

  dxl.torqueOff(DXL_ID_C);
  dxl.setOperatingMode(DXL_ID_C, OP_CURRENT_BASED_POSITION);
  dxl.torqueOn(DXL_ID_C);
}

void loop() {

 dxl.setGoalPosition(DXL_ID_A, 1024, UNIT_RAW); // Set initial position to 0 degrees
 dxl.setGoalPosition(DXL_ID_B, 3072, UNIT_RAW); // Set initial position to 0 degrees
 dxl.setGoalPosition(DXL_ID_C, 1024, UNIT_RAW); // Set initial position to 0 degrees

  if (Serial.available() > 0) {
      String input = Serial.readStringUntil('\n');
    int firstCommaIndex = input.indexOf(',');
    int secondCommaIndex = input.indexOf(',', firstCommaIndex + 1);
    if (firstCommaIndex != -1 && secondCommaIndex != -1) {
      float angleA = input.substring(0, firstCommaIndex).toFloat();
      float angleB = input.substring(firstCommaIndex + 1, secondCommaIndex).toFloat();
      float angleC = input.substring(secondCommaIndex + 1).toFloat();

      Serial.println(angleA);
      Serial.println(angleB);
      Serial.println(angleC);

        DEBUG_SERIAL.print("Present Current(raw) : ");
       DEBUG_SERIAL.println(dxl.getPresentCurrent(DXL_ID_C));

      //dxl.setGoalPosition(DXL_ID_A, angleA, UNIT_DEGREE);
      //dxl.setGoalPosition(DXL_ID_B, angleB, UNIT_DEGREE);
      dxl.setGoalPosition(DXL_ID_C, angleC, UNIT_DEGREE);
      }
    }
  }


//int convertAngleToPosition(float angle) {
  // Conversion logic here
  //return (int)(angle * 2048.0 / 180.0);
//}



